<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/rand-0.7.3/src/distributions/poisson.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>poisson.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../rand/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">// Copyright 2016-2017 The Rust Project Developers.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! The Poisson distribution.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>

<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::<span class="ident">utils</span>::<span class="ident">log_gamma</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::{<span class="ident">Cauchy</span>, <span class="ident">Distribution</span>};
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;

<span class="doccomment">/// The Poisson distribution `Poisson(lambda)`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This distribution has a density function:</span>
<span class="doccomment">/// `f(k) = lambda^k * exp(-lambda) / k!` for `k &gt;= 0`.</span>
<span class="attribute">#[<span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;0.7.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;moved to rand_distr crate&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Poisson</span> {
    <span class="ident">lambda</span>: <span class="ident">f64</span>,
    <span class="comment">// precalculated values</span>
    <span class="ident">exp_lambda</span>: <span class="ident">f64</span>,
    <span class="ident">log_lambda</span>: <span class="ident">f64</span>,
    <span class="ident">sqrt_2lambda</span>: <span class="ident">f64</span>,
    <span class="ident">magic_val</span>: <span class="ident">f64</span>,
}

<span class="kw">impl</span> <span class="ident">Poisson</span> {
    <span class="doccomment">/// Construct a new `Poisson` with the given shape parameter</span>
    <span class="doccomment">/// `lambda`. Panics if `lambda &lt;= 0`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">lambda</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Poisson</span> {
        <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">lambda</span> <span class="op">&gt;</span> <span class="number">0.0</span>, <span class="string">&quot;Poisson::new called with lambda &lt;= 0&quot;</span>);
        <span class="kw">let</span> <span class="ident">log_lambda</span> <span class="op">=</span> <span class="ident">lambda</span>.<span class="ident">ln</span>();
        <span class="ident">Poisson</span> {
            <span class="ident">lambda</span>,
            <span class="ident">exp_lambda</span>: (<span class="op">-</span><span class="ident">lambda</span>).<span class="ident">exp</span>(),
            <span class="ident">log_lambda</span>,
            <span class="ident">sqrt_2lambda</span>: (<span class="number">2.0</span> <span class="op">*</span> <span class="ident">lambda</span>).<span class="ident">sqrt</span>(),
            <span class="ident">magic_val</span>: <span class="ident">lambda</span> <span class="op">*</span> <span class="ident">log_lambda</span> <span class="op">-</span> <span class="ident">log_gamma</span>(<span class="number">1.0</span> <span class="op">+</span> <span class="ident">lambda</span>),
        }
    }
}

<span class="kw">impl</span> <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Poisson</span> {
    <span class="kw">fn</span> <span class="ident">sample</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        <span class="comment">// using the algorithm from Numerical Recipes in C</span>

        <span class="comment">// for low expected values use the Knuth method</span>
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">lambda</span> <span class="op">&lt;</span> <span class="number">12.0</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">result</span> <span class="op">=</span> <span class="number">0</span>;
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">p</span> <span class="op">=</span> <span class="number">1.0</span>;
            <span class="kw">while</span> <span class="ident">p</span> <span class="op">&gt;</span> <span class="self">self</span>.<span class="ident">exp_lambda</span> {
                <span class="ident">p</span> <span class="kw-2">*</span><span class="op">=</span> <span class="ident">rng</span>.<span class="ident">gen</span>::<span class="op">&lt;</span><span class="ident">f64</span><span class="op">&gt;</span>();
                <span class="ident">result</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            }
            <span class="ident">result</span> <span class="op">-</span> <span class="number">1</span>
        }
        <span class="comment">// high expected values - rejection method</span>
        <span class="kw">else</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">int_result</span>: <span class="ident">u64</span>;

            <span class="comment">// we use the Cauchy distribution as the comparison distribution</span>
            <span class="comment">// f(x) ~ 1/(1+x^2)</span>
            <span class="kw">let</span> <span class="ident">cauchy</span> <span class="op">=</span> <span class="ident">Cauchy</span>::<span class="ident">new</span>(<span class="number">0.0</span>, <span class="number">1.0</span>);

            <span class="kw">loop</span> {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">result</span>;
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">comp_dev</span>;

                <span class="kw">loop</span> {
                    <span class="comment">// draw from the Cauchy distribution</span>
                    <span class="ident">comp_dev</span> <span class="op">=</span> <span class="ident">rng</span>.<span class="ident">sample</span>(<span class="ident">cauchy</span>);
                    <span class="comment">// shift the peak of the comparison ditribution</span>
                    <span class="ident">result</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">sqrt_2lambda</span> <span class="op">*</span> <span class="ident">comp_dev</span> <span class="op">+</span> <span class="self">self</span>.<span class="ident">lambda</span>;
                    <span class="comment">// repeat the drawing until we are in the range of possible values</span>
                    <span class="kw">if</span> <span class="ident">result</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0.0</span> {
                        <span class="kw">break</span>;
                    }
                }
                <span class="comment">// now the result is a random variable greater than 0 with Cauchy distribution</span>
                <span class="comment">// the result should be an integer value</span>
                <span class="ident">result</span> <span class="op">=</span> <span class="ident">result</span>.<span class="ident">floor</span>();
                <span class="ident">int_result</span> <span class="op">=</span> <span class="ident">result</span> <span class="kw">as</span> <span class="ident">u64</span>;

                <span class="comment">// this is the ratio of the Poisson distribution to the comparison distribution</span>
                <span class="comment">// the magic value scales the distribution function to a range of approximately 0-1</span>
                <span class="comment">// since it is not exact, we multiply the ratio by 0.9 to avoid ratios greater than 1</span>
                <span class="comment">// this doesn&#39;t change the resulting distribution, only increases the rate of failed drawings</span>
                <span class="kw">let</span> <span class="ident">check</span> <span class="op">=</span> <span class="number">0.9</span>
                    <span class="op">*</span> (<span class="number">1.0</span> <span class="op">+</span> <span class="ident">comp_dev</span> <span class="op">*</span> <span class="ident">comp_dev</span>)
                    <span class="op">*</span> (<span class="ident">result</span> <span class="op">*</span> <span class="self">self</span>.<span class="ident">log_lambda</span> <span class="op">-</span> <span class="ident">log_gamma</span>(<span class="number">1.0</span> <span class="op">+</span> <span class="ident">result</span>) <span class="op">-</span> <span class="self">self</span>.<span class="ident">magic_val</span>).<span class="ident">exp</span>();

                <span class="comment">// check with uniform random value - if below the threshold, we are within the target distribution</span>
                <span class="kw">if</span> <span class="ident">rng</span>.<span class="ident">gen</span>::<span class="op">&lt;</span><span class="ident">f64</span><span class="op">&gt;</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="ident">check</span> {
                    <span class="kw">break</span>;
                }
            }
            <span class="ident">int_result</span>
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="ident">Poisson</span>;
    <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::<span class="ident">Distribution</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">miri</span>, <span class="ident">ignore</span>)]</span> <span class="comment">// Miri is too slow</span>
    <span class="kw">fn</span> <span class="ident">test_poisson_10</span>() {
        <span class="kw">let</span> <span class="ident">poisson</span> <span class="op">=</span> <span class="ident">Poisson</span>::<span class="ident">new</span>(<span class="number">10.0</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">123</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">sum</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">1000</span> {
            <span class="ident">sum</span> <span class="op">+</span><span class="op">=</span> <span class="ident">poisson</span>.<span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
        }
        <span class="kw">let</span> <span class="ident">avg</span> <span class="op">=</span> (<span class="ident">sum</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">/</span> <span class="number">1000.0</span>;
        <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Poisson average: {}&quot;</span>, <span class="ident">avg</span>);
        <span class="macro">assert</span><span class="macro">!</span>((<span class="ident">avg</span> <span class="op">-</span> <span class="number">10.0</span>).<span class="ident">abs</span>() <span class="op">&lt;</span> <span class="number">0.5</span>); <span class="comment">// not 100% certain, but probable enough</span>
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_poisson_15</span>() {
        <span class="comment">// Take the &#39;high expected values&#39; path</span>
        <span class="kw">let</span> <span class="ident">poisson</span> <span class="op">=</span> <span class="ident">Poisson</span>::<span class="ident">new</span>(<span class="number">15.0</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">123</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">sum</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">1000</span> {
            <span class="ident">sum</span> <span class="op">+</span><span class="op">=</span> <span class="ident">poisson</span>.<span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
        }
        <span class="kw">let</span> <span class="ident">avg</span> <span class="op">=</span> (<span class="ident">sum</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">/</span> <span class="number">1000.0</span>;
        <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Poisson average: {}&quot;</span>, <span class="ident">avg</span>);
        <span class="macro">assert</span><span class="macro">!</span>((<span class="ident">avg</span> <span class="op">-</span> <span class="number">15.0</span>).<span class="ident">abs</span>() <span class="op">&lt;</span> <span class="number">0.5</span>); <span class="comment">// not 100% certain, but probable enough</span>
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">should_panic</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_poisson_invalid_lambda_zero</span>() {
        <span class="ident">Poisson</span>::<span class="ident">new</span>(<span class="number">0.0</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">should_panic</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_poisson_invalid_lambda_neg</span>() {
        <span class="ident">Poisson</span>::<span class="ident">new</span>(<span class="op">-</span><span class="number">10.0</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "rand";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>